/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __read, __spreadArray, __values } from "tslib";
import { SpreadsheetChartAdapterBase } from "igniteui-webcomponents-spreadsheet";
import { ChartType_$type } from "igniteui-webcomponents-excel";
import { List$1 } from "igniteui-webcomponents-core";
import { SpreadsheetChartElementInfo } from "igniteui-webcomponents-spreadsheet";
import { markType, IDisposable_$type, NotSupportedException, runOn, typeCast, EnumUtil, String_$type, fromEnum, Array_$type, typeGetValue, Number_$type } from "igniteui-webcomponents-core";
import { Localization } from "igniteui-webcomponents-core";
import { stringIsNullOrEmpty, stringContains, stringEmpty } from "igniteui-webcomponents-core";
import { stringFormat1, stringFormat } from "igniteui-webcomponents-core";
import { SpreadsheetChartAdapterState } from "./SpreadsheetChartAdapterState";
import { ComponentRenderer } from "igniteui-webcomponents-core";
import { ChartElementPlatformHelper } from "./ChartElementPlatformHelper";
import { ChartSeriesInfo } from "./ChartSeriesInfo";
import { Series } from "igniteui-webcomponents-excel";
import { SeriesDescription } from "igniteui-webcomponents-core";
import { ChartEmptyFill } from "igniteui-webcomponents-excel";
import { Dictionary$2 } from "igniteui-webcomponents-core";
import { SpreadsheetChartAdapter_ScatterSeriesDataItem } from "./SpreadsheetChartAdapter_ScatterSeriesDataItem";
import { Enumerable } from "igniteui-webcomponents-core";
import { SpreadsheetChartAdapter_SeriesDataItem } from "./SpreadsheetChartAdapter_SeriesDataItem";
import { HashSet$1 } from "igniteui-webcomponents-core";
import { SpreadsheetChartAdapterHelpers } from "./SpreadsheetChartAdapterHelpers";
import { SpreadsheetChartAdapter_PieDataItem } from "./SpreadsheetChartAdapter_PieDataItem";
import { SpreadsheetChartAdapter_StackedSeriesDataItem } from "./SpreadsheetChartAdapter_StackedSeriesDataItem";
import { Convert } from "igniteui-webcomponents-core";
import { SpreadsheetChartAdapter_StockDataItem } from "./SpreadsheetChartAdapter_StockDataItem";
import { DataChartDescription } from "igniteui-webcomponents-core";
import { AxisInfos } from "./AxisInfos";
import { SeriesType_$type } from "igniteui-webcomponents-excel";
import { DataChartCategoryCoreDescriptionModule } from "igniteui-webcomponents-core";
import { DataChartCategoryDescriptionModule } from "igniteui-webcomponents-core";
import { DataChartVerticalCategoryDescriptionModule } from "igniteui-webcomponents-core";
import { HorizontalAnchoredCategorySeriesDescription } from "igniteui-webcomponents-core";
import { SeriesViewerDescription } from "igniteui-webcomponents-core";
import { DoughnutChartDescription } from "igniteui-webcomponents-core";
import { RingSeriesDescription } from "igniteui-webcomponents-core";
import { DoughnutChartDescriptionMetadata } from "igniteui-webcomponents-core";
import { LegendDescriptionModule } from "igniteui-webcomponents-core";
import { ItemLegendDescriptionModule } from "igniteui-webcomponents-core";
import { ItemLegendDescription } from "igniteui-webcomponents-core";
import { LegendDescription } from "igniteui-webcomponents-core";
import { PieChartDescription } from "igniteui-webcomponents-core";
import { PieChartDescriptionModule } from "igniteui-webcomponents-core";
import { NumericYAxisDescription } from "igniteui-webcomponents-core";
import { DataChartFinancialDescriptionModule } from "igniteui-webcomponents-core";
import { CategoryXAxisDescription } from "igniteui-webcomponents-core";
import { LineSeriesDescription } from "igniteui-webcomponents-core";
import { AnchoredCategorySeriesDescription } from "igniteui-webcomponents-core";
import { ColumnSeriesDescription } from "igniteui-webcomponents-core";
import { FinancialPriceSeriesDescription } from "igniteui-webcomponents-core";
import { PriceDisplayType_$type } from "igniteui-webcomponents-charts";
import { RowColLength } from "./RowColLength";
import { MarkerType_$type } from "igniteui-webcomponents-charts";
import { MarkerSeriesDescription } from "igniteui-webcomponents-core";
import { StackedFragmentSeriesDescription } from "igniteui-webcomponents-core";
import { BubbleSeriesDescription } from "igniteui-webcomponents-core";
import { TrendLineType_$type } from "igniteui-webcomponents-core";
import { StackedSeriesBaseDescription } from "igniteui-webcomponents-core";
import { ScatterBaseDescription } from "igniteui-webcomponents-core";
import { PolarBaseDescription } from "igniteui-webcomponents-core";
import { StackedColumnSeriesDescription } from "igniteui-webcomponents-core";
import { Stacked100ColumnSeriesDescription } from "igniteui-webcomponents-core";
import { StackedBarSeriesDescription } from "igniteui-webcomponents-core";
import { Stacked100BarSeriesDescription } from "igniteui-webcomponents-core";
import { BarSeriesDescription } from "igniteui-webcomponents-core";
import { StackedLineSeriesDescription } from "igniteui-webcomponents-core";
import { Stacked100LineSeriesDescription } from "igniteui-webcomponents-core";
import { AreaSeriesDescription } from "igniteui-webcomponents-core";
import { StackedAreaSeriesDescription } from "igniteui-webcomponents-core";
import { Stacked100AreaSeriesDescription } from "igniteui-webcomponents-core";
import { HorizontalStackedSeriesBaseDescription } from "igniteui-webcomponents-core";
import { VerticalStackedSeriesBaseDescription } from "igniteui-webcomponents-core";
import { VerticalAnchoredCategorySeriesDescription } from "igniteui-webcomponents-core";
import { RingSeriesBaseDescriptionMetadata } from "igniteui-webcomponents-core";
import { RingSeriesDescriptionMetadata } from "igniteui-webcomponents-core";
import { HierarchicalRingSeriesDescriptionMetadata } from "igniteui-webcomponents-core";
import { DataChartRadialCoreDescriptionModule } from "igniteui-webcomponents-core";
import { DataChartRadialDescriptionModule } from "igniteui-webcomponents-core";
import { RadialLineSeriesDescription } from "igniteui-webcomponents-core";
import { RadialAreaSeriesDescription } from "igniteui-webcomponents-core";
import { DataChartScatterDescriptionModule } from "igniteui-webcomponents-core";
import { ScatterSeriesDescription } from "igniteui-webcomponents-core";
import { ScatterLineSeriesDescription } from "igniteui-webcomponents-core";
import { ScatterSplineSeriesDescription } from "igniteui-webcomponents-core";
import { DataChartStackedDescriptionModule } from "igniteui-webcomponents-core";
import { StraightNumericAxisBaseDescription } from "igniteui-webcomponents-core";
import { truncate, log10 } from "igniteui-webcomponents-core";
/**
 * Creates and initializes chart elements for the spreadsheet based on a [[WorksheetChart]] instance.
 */
var SpreadsheetChartAdapter = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SpreadsheetChartAdapter, _super);
    function SpreadsheetChartAdapter() {
        var _this = _super.call(this) || this;
        _this._d = null;
        /**
         * @hidden
         */
        _this._e = null;
        /**
         * @hidden
         */
        _this._c = null;
        _this._e = new List$1(ChartType_$type, 1, [1, 76, 77, 57, 58, 59, 15, 87, 51, 52, 53, 113, -4120, 80, 4, 63, 64, 65, 66, 67, 5, -4102, 70, 69, -4151, 82, 81, 88, 89, 90, 91, -4169, 74, 75, 72, 73]);
        return _this;
    }
    /**
     * @hidden
     */
    SpreadsheetChartAdapter.prototype._a = function (a, b) {
        this._c = b;
        var c = function (d, e) { return b._v.createChartTitleElement(d.chartTitle, e); };
        return this._d = new SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate(this, a, c);
    };
    /**
     * @hidden
     */
    SpreadsheetChartAdapter.prototype._b = function (a) {
        return this._e.contains(a.chartType);
    };
    /**
     * @hidden
     */
    SpreadsheetChartAdapter.prototype._s = function (a) {
        var b = [];
        for (var _0 = 1; _0 < arguments.length; _0++) {
            b[_0 - 1] = arguments[_0];
        }
        var c;
        c = Localization.getString.apply(Localization, __spreadArray(["spreadsheetchartadapter", a], __read(b), false));
        if (!stringIsNullOrEmpty(c) && b != null && b.length > 0) {
            c = stringFormat1.apply(void 0, __spreadArray([c], __read(b), false));
        }
        return c;
        return "GetResourceString not Implemented!!!!!!";
    };
    SpreadsheetChartAdapter.$t = markType(SpreadsheetChartAdapter, 'SpreadsheetChartAdapter', SpreadsheetChartAdapterBase.$);
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._x = "datachart";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._z = "piechart";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._y = "doughnutchart";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._u = "groupedseriesdata{0}";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._t = "groupedscatterseriesdata{0}";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ab = "stackedseriesdata";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._w = "piedata";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ac = "stockdata";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._v = "piecharttooltip";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._q = "doughnutcharttooltip";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._g = "legend";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._aa = "seriestooltip{0}";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._r = "fragmentseriestitle{0}";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._f = "axiscrossingvalue-{0}";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ak = "XAxis";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ai = "Prices";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._aj = "Volume";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ae = "High";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._af = "Low";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ad = "Close";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ag = "Open";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ah = "Volume";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._m = "XAxisPrimary";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._n = "XAxisSecondary";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._o = "YAxisPrimary";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._p = "YAxisSecondary";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._j = "CategoryAngleAxis";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._l = "NumericRadiusAxis";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._k = "NumericAngleAxis";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._h = "rgba(0, 0, 0, 0)";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._i = "rgba(255, 255, 255, 0)";
    return SpreadsheetChartAdapter;
}(SpreadsheetChartAdapterBase));
export { SpreadsheetChartAdapter };
/**
 * @hidden
 */
var SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate, _super);
    function SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate(a, b, c) {
        var _this = _super.call(this) || this;
        _this.ae = null;
        _this.a8 = null;
        _this.ai = false;
        _this.bb = null;
        _this.am = false;
        _this.k = null;
        _this.l = null;
        _this.m = null;
        _this.aj = false;
        _this.ak = false;
        _this.a1 = null;
        _this.ay = null;
        _this.a0 = null;
        _this.ax = null;
        _this.a2 = null;
        _this.az = null;
        _this.a3 = null;
        _this.bd = null;
        _this.bc = null;
        _this.af = null;
        _this.al = false;
        _this.aw = null;
        _this.a7 = -1;
        _this.ad = null;
        _this.a9 = null;
        _this.ba = null;
        _this.an = false;
        _this.ac = null;
        _this.ah = null;
        _this.ac = new ChartElementPlatformHelper(a._c, runOn(_this, _this.bs));
        _this.ae = a;
        _this.c = b;
        _this.ad = c;
        _this.f = _this.ac.p();
        _this.ad = c;
        _this.k = new ComponentRenderer();
        _this.aj = true;
        _this.ak = true;
        _this.ah = _this.c.worksheet.workbook;
        _this.bh();
        return _this;
    }
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.h = function () {
        if (null != this.a8 && typeCast(IDisposable_$type, this.a8) !== null) {
            this.a8.dispose();
        }
        if (null != this.bb && typeCast(IDisposable_$type, this.bb) !== null) {
            this.bb.dispose();
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.i = function () {
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.e = function (a, b, c) {
        if (a != this.c) {
            b = true;
            c = true;
            this.c = a;
        }
        else if (false == b && false == c) {
            return true;
        }
        this.al = true;
        if (b || c) {
            this.bv();
        }
        if (c) {
            this.bu();
        }
        this.bh();
        this.aj = false;
        this.ak = false;
        this.al = false;
        return true;
    };
    Object.defineProperty(SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype, "ag", {
        get: function () {
            if (null == this.af) {
                this.af = new SpreadsheetChartAdapterState(this.c, this.a8, this.bb, this.k, this.ac);
            }
            return this.af;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype, "a4", {
        get: function () {
            return this.aw;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype, "aq", {
        get: function () {
            return (null != this.c.legend && null != this.m && null != this.bb);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype, "ar", {
        get: function () {
            return 113 == this.c.chartType;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype, "at", {
        get: function () {
            switch (this.c.chartType) {
                case 88:
                case 89:
                case 90:
                case 91: return true;
                default: return false;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype, "as", {
        get: function () {
            return stringContains(EnumUtil.getName(ChartType_$type, this.c.chartType), "Stacked");
        },
        enumerable: false,
        configurable: true
    });
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.be = function () {
        var _this = this;
        if (null == this.a8) {
            this.a8 = ((function () { var a = _this.ac.o(_this.ai); _this.ai = a.p0; return a.ret; })());
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bg = function () {
        var _this = this;
        if (null != this.c.legend) {
            if (null == this.bb) {
                this.bb = ((function () { var a = _this.ac.o(_this.am); _this.am = a.p0; return a.ret; })());
            }
        }
        else if (null != this.bb) {
            this.ac.h(this.bb, this.f);
            if (null != this.a8) {
                this.ac.h(this.bb, this.a8);
            }
            this.bb = null;
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bf = function (a, b, c, d, e, f, g, h, i) {
        if (i === void 0) {
            i = null;
        }
        if (null != a && (false == (typeCast(ChartEmptyFill.$, a.line.fill) !== null))) {
            f.add(this.v(a, "High", g, h));
        }
        if (null != b && (false == (typeCast(ChartEmptyFill.$, b.line.fill) !== null))) {
            f.add(this.v(b, "Low", g, h));
        }
        if (null != c && (false == (typeCast(ChartEmptyFill.$, c.line.fill) !== null))) {
            f.add(this.v(c, "Close", g, h));
        }
        if (null != d && (false == (typeCast(ChartEmptyFill.$, d.line.fill) !== null))) {
            f.add(this.v(d, "Open", g, h));
        }
        if (null != e && null != e.line && (false == (typeCast(ChartEmptyFill.$, e.line.fill) !== null))) {
            f.add(this.v(e, "Volume", g, i));
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bh = function () {
        this.an = true;
        this.be();
        this.bg();
        if (false == this.ai) {
            return;
        }
        this.bi();
        this.ao();
        if (null == this.l) {
            return;
        }
        this.bl();
        if (this.aq && false == this.am) {
            return;
        }
        this.an = false;
        this.by();
        this.bt();
        this.bw();
        this.bx();
        this.a7 = this.aw.count;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.ao = function (a) {
        if (a === void 0) {
            a = true;
        }
        if (null == this.l || this.aj) {
        }
        else {
            return true;
        }
        if (a) {
            this.l = null;
        }
        switch (this.c.chartType) {
            case 1:
            case 76:
            case 77:
                if (a) {
                    this.b6();
                    this.l = this.n();
                }
                else {
                    return true;
                }
                break;
            case -4098: break;
            case 78: break;
            case 79: break;
            case 60: break;
            case 61: break;
            case 62: break;
            case 57:
            case 58:
            case 59:
                if (a) {
                    this.b6();
                    this.l = this.n();
                }
                else {
                    return true;
                }
                break;
            case 71: break;
            case 15:
            case 87:
                if (a) {
                    this.b6();
                    this.l = this.n();
                }
                else {
                    return true;
                }
                break;
            case -4100: break;
            case 54: break;
            case 55: break;
            case 56: break;
            case 51:
            case 52:
            case 53:
                if (a) {
                    this.b6();
                    this.l = this.n();
                }
                else {
                    return true;
                }
                break;
            case 113:
                if (a) {
                    this.b6();
                    this.l = this.n();
                }
                else {
                    return true;
                }
                break;
            case 102: break;
            case 103: break;
            case 104: break;
            case 105: break;
            case 99: break;
            case 100: break;
            case 101: break;
            case 95: break;
            case 96: break;
            case 97: break;
            case 98: break;
            case 92: break;
            case 93: break;
            case 94: break;
            case -4120:
            case 80:
                if (a) {
                    this.b6();
                    this.l = this.o();
                }
                else {
                    return true;
                }
                break;
            case 4:
            case 63:
            case 64:
            case 65:
            case 66:
            case 67:
                if (a) {
                    this.b6();
                    this.l = this.n();
                }
                else {
                    return true;
                }
                break;
            case -4101: break;
            case 5:
            case -4102:
            case 70:
            case 69:
                if (a) {
                    this.b6();
                    this.l = this.p();
                }
                else {
                    return true;
                }
                break;
            case 68: break;
            case 109: break;
            case 110: break;
            case 111: break;
            case 112: break;
            case 106: break;
            case 107: break;
            case 108: break;
            case -4151:
            case 82:
            case 81:
                if (a) {
                    this.b6();
                    this.l = this.n();
                }
                else {
                    return true;
                }
                break;
            case 88:
            case 89:
            case 90:
            case 91:
                if (a) {
                    this.b6();
                    this.l = this.r();
                }
                else {
                    return true;
                }
                break;
            case 83:
            case 84: break;
            case 85:
            case 86: break;
            case -4169:
            case 74:
            case 75:
            case 72:
            case 73:
                if (a) {
                    this.b6();
                    this.l = this.n();
                }
                else {
                    return true;
                }
                break;
        }
        if (null == this.l) {
            throw new NotSupportedException(1, this.ae._s("Error_ChartTypeNotSupportedForRendering", EnumUtil.getName(ChartType_$type, this.c.chartType)));
        }
        return true;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bj = function () {
        var e_1, _0;
        if (false == this.aj) {
            return;
        }
        this.a0 = this.a5();
        var a = new Dictionary$2(String_$type, List$1.$.specialize(SpreadsheetChartAdapter_ScatterSeriesDataItem.$), 0);
        try {
            for (var _1 = __values(fromEnum(this.a0)), _2 = _1.next(); !_2.done; _2 = _1.next()) {
                var b = _2.value;
                var c = b.SeriesName;
                if (a.containsKey(c)) {
                    a.item(c).add(b);
                }
                else {
                    a.item(c, new List$1(SpreadsheetChartAdapter_ScatterSeriesDataItem.$, 0));
                    a.item(c).add(b);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_2 && !_2.done && (_0 = _1.return))
                    _0.call(_1);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        for (var d = 0; d < a.values.count; d++) {
            var e = stringFormat("groupedscatterseriesdata{0}", d.toString());
            this.ac.g(this.k, this.a8, e, Enumerable.z(List$1.$.specialize(SpreadsheetChartAdapter_ScatterSeriesDataItem.$), a.values)._inner[d].toArray());
        }
        this.ax = Enumerable.z(List$1.$.specialize(SpreadsheetChartAdapter_ScatterSeriesDataItem.$), a.values);
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bk = function (a) {
        var e_2, _0;
        if (a === void 0) {
            a = 0;
        }
        if (false == this.aj) {
            return;
        }
        this.a1 = this.a6();
        var b = new Dictionary$2(String_$type, List$1.$.specialize(SpreadsheetChartAdapter_SeriesDataItem.$), 0);
        try {
            for (var _1 = __values(fromEnum(this.a1)), _2 = _1.next(); !_2.done; _2 = _1.next()) {
                var c = _2.value;
                var d = (a == 0) ? c.Row : c.Col;
                if (b.containsKey(d)) {
                    b.item(d).add(c);
                }
                else {
                    b.item(d, new List$1(SpreadsheetChartAdapter_SeriesDataItem.$, 0));
                    b.item(d).add(c);
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_2 && !_2.done && (_0 = _1.return))
                    _0.call(_1);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        for (var e = 0; e < b.values.count; e++) {
            var f = stringFormat("groupedseriesdata{0}", e.toString());
            this.ac.g(this.k, this.a8, f, Enumerable.z(List$1.$.specialize(SpreadsheetChartAdapter_SeriesDataItem.$), b.values)._inner[e].toArray());
        }
        this.ay = Enumerable.z(List$1.$.specialize(SpreadsheetChartAdapter_SeriesDataItem.$), b.values);
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bi = function () {
        var e_3, _0;
        this.aw = new List$1(ChartSeriesInfo.$, 0);
        var a = new HashSet$1(String_$type, 0);
        var b = 0;
        var _loop_1 = function (c) {
            if (false == this_1.au(c)) {
                var d = SpreadsheetChartAdapterHelpers.v(c, b + 1);
                var e_4 = d;
                while (a.contains(e_4)) {
                    e_4 = d + this_1.ag.e().toString();
                }
                a.add_1(e_4);
                var f_1 = SpreadsheetChartAdapterHelpers.w(c, b + 1);
                this_1.aw.add(((function () {
                    var $ret = new ChartSeriesInfo();
                    $ret.a = c;
                    $ret.c = e_4;
                    $ret.d = f_1;
                    $ret.b = b;
                    return $ret;
                })()));
                b++;
            }
        };
        var this_1 = this;
        try {
            for (var _1 = __values(fromEnum(this.c._seriesCollection$i)), _2 = _1.next(); !_2.done; _2 = _1.next()) {
                var c = _2.value;
                _loop_1(c);
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_2 && !_2.done && (_0 = _1.return))
                    _0.call(_1);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bm = function () {
        var e_5, _0, e_6, _1;
        if (false == this.aj) {
            return;
        }
        this.a1 = this.a6();
        var a = new Dictionary$2(String_$type, List$1.$.specialize(SpreadsheetChartAdapter_SeriesDataItem.$), 0);
        try {
            for (var _2 = __values(fromEnum(this.a1)), _3 = _2.next(); !_3.done; _3 = _2.next()) {
                var b = _3.value;
                var c = b.Row;
                if (a.containsKey(c)) {
                    a.item(c).add(b);
                }
                else {
                    a.item(c, new List$1(SpreadsheetChartAdapter_SeriesDataItem.$, 0));
                    a.item(c).add(b);
                }
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_3 && !_3.done && (_0 = _2.return))
                    _0.call(_2);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
        var d = Enumerable.z(List$1.$.specialize(SpreadsheetChartAdapter_SeriesDataItem.$), a.values);
        this.az = new List$1(SpreadsheetChartAdapter_PieDataItem.$, 0);
        var _loop_2 = function (e) {
            var f = ((function () {
                var $ret = new SpreadsheetChartAdapter_PieDataItem();
                $ret.CategoryName = e._inner[0].Row;
                $ret.Value = e._inner[0].Value;
                $ret.SeriesName = e._inner[0].Col;
                return $ret;
            })());
            this_2.az.add(f);
        };
        var this_2 = this;
        try {
            for (var _4 = __values(fromEnum(d)), _5 = _4.next(); !_5.done; _5 = _4.next()) {
                var e = _5.value;
                _loop_2(e);
            }
        }
        catch (e_6_1) {
            e_6 = { error: e_6_1 };
        }
        finally {
            try {
                if (_5 && !_5.done && (_1 = _4.return))
                    _1.call(_4);
            }
            finally {
                if (e_6)
                    throw e_6.error;
            }
        }
        this.ac.g(this.k, this.a8, "piedata", this.az.toArray());
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bl = function () {
        if (null != this.c.legend) {
            if (null != this.m) {
                return;
            }
        }
        else if (null != this.m) {
            this.m = null;
            return;
        }
        this.bp();
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bn = function () {
        if (false == this.aj) {
            return;
        }
        this.a2 = new List$1(SpreadsheetChartAdapter_StackedSeriesDataItem.$, 0);
        var a;
        var b;
        var c = this.bq(this.a4._inner[0].a, b, a);
        b = c.p1;
        a = c.p2;
        var d = new List$1(Array_$type, 0);
        d.add(b);
        for (var e = 1; e < this.a4.count; e++) {
            var f = void 0;
            var g = void 0;
            var h = this.bq(this.a4._inner[e].a, g, f);
            g = h.p1;
            f = h.p2;
            d.add(g);
        }
        var i = a.length;
        var j = b.length;
        var k = 0;
        var l = this.a4.count;
        var m = ((function () {
            var $firstRank;
            var $ret = new Array($firstRank = i);
            var $currRet = $ret;
            for (var $rankInit = 0; $rankInit < $firstRank; $rankInit++) {
                $currRet[$rankInit] = new Array(l);
            }
            return $ret;
        })());
        for (var n = 0; n < i; n++) {
            for (var o = 0; o < d.count; o++) {
                var p = d._inner[o];
                m[k][o] = Convert.toDouble3(p[k]);
            }
            k++;
        }
        k = 0;
        var _loop_3 = function (q) {
            var e_7, _0;
            var r = new Array(l);
            var s = new Array(l);
            var t = 0;
            try {
                for (var _1 = (e_7 = void 0, __values(fromEnum(this_3.a4))), _2 = _1.next(); !_2.done; _2 = _1.next()) {
                    var u = _2.value;
                    r[t] = Convert.toDouble3(m[k][t]);
                    s[t] = u.c;
                    t++;
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_2 && !_2.done && (_0 = _1.return))
                        _0.call(_1);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
            var v = ((function () {
                var $ret = new SpreadsheetChartAdapter_StackedSeriesDataItem();
                $ret.CategoryName = a[q].toString();
                $ret.SeriesValues = r;
                $ret.SeriesNames = s;
                return $ret;
            })());
            this_3.a2.add(v);
            k++;
        };
        var this_3 = this;
        for (var q = 0; q < i; q++) {
            _loop_3(q);
        }
        this.ac.g(this.k, this.a8, "stackedseriesdata", this.a2.toArray());
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bo = function () {
        var e_8, _0, e_9, _1;
        if (false == this.aj) {
            return;
        }
        this.a3 = new List$1(SpreadsheetChartAdapter_StockDataItem.$, 0);
        this.a1 = this.a6();
        var a = this.c.chartType;
        var b = stringEmpty();
        var c = null;
        var d = -1;
        var e = new Dictionary$2(String_$type, SpreadsheetChartAdapter_StockDataItem.$, 0);
        var _loop_4 = function (f) {
            if (false == e.containsKey(f.Row)) {
                c = ((function () {
                    var $ret = new SpreadsheetChartAdapter_StockDataItem();
                    $ret.CategoryName = f.Row;
                    return $ret;
                })());
                e.addItem(f.Row, c);
            }
            else {
                c = e.item(f.Row);
            }
            if (f.Col != b) {
                d++;
                b = f.Col;
            }
            c.g(a, d, f.Value);
        };
        try {
            for (var _2 = __values(fromEnum(this.a1)), _3 = _2.next(); !_3.done; _3 = _2.next()) {
                var f = _3.value;
                _loop_4(f);
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_3 && !_3.done && (_0 = _2.return))
                    _0.call(_2);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        try {
            for (var _4 = __values(fromEnum(e.values)), _5 = _4.next(); !_5.done; _5 = _4.next()) {
                var g = _5.value;
                this.a3.add(g);
            }
        }
        catch (e_9_1) {
            e_9 = { error: e_9_1 };
        }
        finally {
            try {
                if (_5 && !_5.done && (_1 = _4.return))
                    _1.call(_4);
            }
            finally {
                if (e_9)
                    throw e_9.error;
            }
        }
        this.ac.g(this.k, this.a8, "stockdata", this.a3.toArray());
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.n = function () {
        var e_10, _0, e_11, _1, e_12, _2, e_13, _3;
        this.ac.u("datachart");
        DataChartCategoryCoreDescriptionModule.register(this.k.context);
        DataChartCategoryDescriptionModule.register(this.k.context);
        DataChartVerticalCategoryDescriptionModule.register(this.k.context);
        var a = new DataChartDescription();
        var b = new AxisInfos();
        try {
            for (var _4 = __values(fromEnum(this.c._axisCollection$i)), _5 = _4.next(); !_5.done; _5 = _4.next()) {
                var c = _5.value;
                switch (c.type) {
                    case 1:
                        this.bk();
                        if (this.c.chartType == -4151 || this.c.chartType == 81 || this.c.chartType == 82) {
                            b.l(SpreadsheetChartAdapterHelpers.f(c, this.ag));
                        }
                        else {
                            b.l(SpreadsheetChartAdapterHelpers.g(c, this.ag));
                        }
                        break;
                    case 2:
                        if (this.c.chartType == -4151 || this.c.chartType == 81 || this.c.chartType == 82) {
                            b.l(SpreadsheetChartAdapterHelpers.h(c, this.ag));
                        }
                        else {
                            b.l(SpreadsheetChartAdapterHelpers.i(c, this.ag));
                        }
                        break;
                    case 3: break;
                }
            }
        }
        catch (e_10_1) {
            e_10 = { error: e_10_1 };
        }
        finally {
            try {
                if (_5 && !_5.done && (_0 = _4.return))
                    _0.call(_4);
            }
            finally {
                if (e_10)
                    throw e_10.error;
            }
        }
        var d = new List$1(SeriesDescription.$, 0);
        var e = 0;
        var f = false;
        var g = 0;
        var h = new Dictionary$2(Series.$, SeriesDescription.$, 0);
        var i = new Dictionary$2(SeriesDescription.$, Series.$, 0);
        try {
            for (var _6 = __values(fromEnum(this.a4)), _7 = _6.next(); !_7.done; _7 = _6.next()) {
                var j = _7.value;
                var k = j.a;
                if (stringContains(EnumUtil.getName(ChartType_$type, k.chartType), "Stacked")) {
                    g++;
                    if (g > 1) {
                        e++;
                        continue;
                    }
                }
                if (this.ar && SpreadsheetChartAdapterHelpers.k(k)) {
                    f = true;
                }
                var l = typeCast(SeriesDescription.$, this.q(k, e, b));
                if (null != l) {
                    d.add(l);
                    h.addItem(k, l);
                    i.addItem(l, k);
                    if (stringContains(EnumUtil.getName(ChartType_$type, k.chartType), "Stacked")) {
                        try {
                            for (var _8 = (e_12 = void 0, __values(fromEnum(b.b))), _9 = _8.next(); !_9.done; _9 = _8.next()) {
                                var m = _9.value;
                                if (m.d) {
                                    m.a.label = "CategoryName";
                                    m.a.dataSourceRef = "stackedseriesdata";
                                }
                            }
                        }
                        catch (e_12_1) {
                            e_12 = { error: e_12_1 };
                        }
                        finally {
                            try {
                                if (_9 && !_9.done && (_2 = _8.return))
                                    _2.call(_8);
                            }
                            finally {
                                if (e_12)
                                    throw e_12.error;
                            }
                        }
                    }
                }
                else {
                    throw new NotSupportedException(1, this.ae._s("Error_UnsupportedSeriesType", EnumUtil.getName(SeriesType_$type, k.type)));
                }
                e++;
            }
        }
        catch (e_11_1) {
            e_11 = { error: e_11_1 };
        }
        finally {
            try {
                if (_7 && !_7.done && (_1 = _6.return))
                    _1.call(_6);
            }
            finally {
                if (e_11)
                    throw e_11.error;
            }
        }
        if (this.ar && f) {
            try {
                for (var _10 = __values(fromEnum(h.keys)), _11 = _10.next(); !_11.done; _11 = _10.next()) {
                    var n = _11.value;
                    if (false == SpreadsheetChartAdapterHelpers.k(n)) {
                        var o = h.item(n);
                        if (typeCast(HorizontalAnchoredCategorySeriesDescription.$, o) !== null && o.xAxisRef == "XAxisSecondary") {
                            o.xAxisRef = "XAxisPrimary";
                            o.yAxisRef = "YAxisPrimary";
                        }
                    }
                }
            }
            catch (e_13_1) {
                e_13 = { error: e_13_1 };
            }
            finally {
                try {
                    if (_11 && !_11.done && (_3 = _10.return))
                        _3.call(_10);
                }
                finally {
                    if (e_13)
                        throw e_13.error;
                }
            }
        }
        if (this.al) {
            if (this.a7 != -1 && (this.a7 != this.a4.count)) {
                a.axes = new Array(0);
                a.series = new Array(0);
                this.bw(a);
            }
        }
        this.b4(b);
        this.b7(d);
        a.axes = b.a();
        a.series = Enumerable.a(SeriesDescription.$, d);
        a.shouldAutoExpandMarginForInitialLabels = true;
        a.shouldConsiderAutoRotationForInitialLabels = true;
        a.autoMarginAndAngleUpdateMode = "SizeChanging";
        this.bz(a);
        var p = "GetDVDataChart1";
        return a;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.o = function () {
        var e_14, _0;
        this.ac.u("doughnutchart");
        DoughnutChartDescriptionMetadata.d(this.k.context);
        var a = new DoughnutChartDescription();
        this.bc = "Series '{Col}' Point '{Row}' Value: {Value}";
        this.ac.g(this.k, this.a8, "doughnutcharttooltip", this.bc);
        var b = 0;
        var c = new List$1(RingSeriesDescription.$, 0);
        try {
            for (var _1 = __values(fromEnum(this.a4)), _2 = _1.next(); !_2.done; _2 = _1.next()) {
                var d = _2.value;
                var e = d.a;
                if (null == e.values || e.values.getValues().length < 1) {
                    b++;
                    continue;
                }
                var f = typeCast(RingSeriesDescription.$, this.q(e, b, null));
                if (null != f) {
                    f.startAngle = Math.max(-360, this.c.firstSliceAngle - 90);
                    c.add(f);
                    f.tooltipTemplateRef = "doughnutcharttooltip";
                    f.brushes = SpreadsheetChartAdapterHelpers.b(e, b);
                }
                else {
                    throw new NotSupportedException(1, this.ae._s("Error_UnsupportedSeriesType", EnumUtil.getName(SeriesType_$type, e.type)));
                }
                b++;
            }
        }
        catch (e_14_1) {
            e_14 = { error: e_14_1 };
        }
        finally {
            try {
                if (_2 && !_2.done && (_0 = _1.return))
                    _0.call(_1);
            }
            finally {
                if (e_14)
                    throw e_14.error;
            }
        }
        a.innerExtent = this.c.doughnutHoleSize;
        a.series = Enumerable.a(RingSeriesDescription.$, c);
        var g = SpreadsheetChartAdapterHelpers.r(this.c.plotArea._ap, this.ah);
        if (false == stringIsNullOrEmpty(g)) {
            a.background = g;
        }
        else {
            a.background = "rgba(0, 0, 0, 0)";
        }
        return a;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bp = function () {
        if (null == this.c.legend) {
            return;
        }
        LegendDescriptionModule.register(this.k.context);
        ItemLegendDescriptionModule.register(this.k.context);
        switch (this.c.chartType) {
            case 5:
            case 71:
            case -4102:
            case 70:
            case 69:
            case 68:
            case -4120:
            case 80:
                this.m = new ItemLegendDescription();
                break;
            default:
                this.m = new LegendDescription();
                break;
        }
        this.m.name = "legend";
        var a = SpreadsheetChartAdapterHelpers.r(this.c.legend._af, this.ah);
        if (false == stringIsNullOrEmpty(a)) {
            this.m.background = a;
        }
        else {
            this.m.background = "rgba(0, 0, 0, 0)";
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.p = function () {
        this.ac.u("piechart");
        PieChartDescriptionModule.register(this.k.context);
        this.bm();
        var a = new PieChartDescription();
        a.dataSourceRef = "piedata";
        a.valueMemberPath = "Value";
        a.labelMemberPath = "CategoryName";
        a.legendRef = "legend";
        a.startAngle = Math.max(-360, this.c.firstSliceAngle - 90);
        this.bd = "Series '{SeriesName}' Point '{CategoryName}' Value: {Value}";
        this.ac.g(this.k, this.a8, "piecharttooltip", this.bd);
        a.tooltipTemplateRef = "piecharttooltip";
        if (this.a4.count > 0) {
            var b_1 = 0;
            var c_1 = this.a4._inner[b_1].a;
            a.brushes = SpreadsheetChartAdapterHelpers.b(c_1, b_1);
            var d_1 = 0;
            a.explodedSlices = ((function () { var e = SpreadsheetChartAdapterHelpers.a(c_1, b_1, d_1); d_1 = e.p2; return e.ret; })());
            a.explodedRadius = Math.max(d_1, c_1.explosion) / 100;
            a.othersCategoryThreshold = -1.7976931348623157E+308;
        }
        var e = SpreadsheetChartAdapterHelpers.r(this.c.plotArea._ap, this.ah);
        if (false == stringIsNullOrEmpty(e)) {
            a.background = e;
        }
        else {
            a.background = "rgba(0, 0, 0, 0)";
        }
        return a;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.q = function (a, b, c) {
        switch (a.type) {
            case 0:
            case 2:
            case 1: return this.z(a, b);
            case 3: return this.u(a, b);
            case 4: return this.aa(a, b, c);
            case 6:
            case 7: return this.ab(a, b, c);
            case 5: break;
        }
        return null;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.r = function () {
        if (!this.at) {
            return null;
        }
        this.ac.u("datachart");
        DataChartFinancialDescriptionModule.register(this.k.context);
        DataChartCategoryDescriptionModule.register(this.k.context);
        var a = null;
        this.bo();
        switch (this.c.chartType) {
            case 88:
                {
                    if (false == this.av(1, 1, 0)) {
                        throw new NotSupportedException(1, this.ae._s("Error_InvalidAxesCountOrTypeForChartType", EnumUtil.getName(ChartType_$type, this.c.chartType)));
                    }
                    a = new DataChartDescription();
                    var b = this.j(SpreadsheetChartAdapterHelpers.j(0, this.c._axisCollection$i, this.ag));
                    var c = this.s(SpreadsheetChartAdapterHelpers.j(1, this.c._axisCollection$i, this.ag));
                    a.axes = [b, c];
                    var d = new List$1(SeriesDescription.$, 0);
                    d.add(this.w(b.name, c.name));
                    var e = this.a4.count > 0 ? this.a4._inner[0].a : null;
                    var f = this.a4.count > 1 ? this.a4._inner[1].a : null;
                    var g = this.a4.count > 2 ? this.a4._inner[2].a : null;
                    this.bf(e, f, g, null, null, d, b.name, c.name);
                    a.series = Enumerable.a(SeriesDescription.$, d);
                    break;
                }
            case 89:
                {
                    if (false == this.av(1, 1, 0)) {
                        throw new NotSupportedException(1, this.ae._s("Error_InvalidAxesCountOrTypeForChartType", EnumUtil.getName(ChartType_$type, this.c.chartType)));
                    }
                    a = new DataChartDescription();
                    var h = this.j(SpreadsheetChartAdapterHelpers.j(0, this.c._axisCollection$i, this.ag));
                    var i = this.s(SpreadsheetChartAdapterHelpers.j(1, this.c._axisCollection$i, this.ag));
                    a.axes = [h, i];
                    var j = new List$1(SeriesDescription.$, 0);
                    j.add(this.x(h.name, i.name));
                    var k = this.a4.count > 0 ? this.a4._inner[0].a : null;
                    var l = this.a4.count > 1 ? this.a4._inner[1].a : null;
                    var m = this.a4.count > 2 ? this.a4._inner[2].a : null;
                    var n = this.a4.count > 3 ? this.a4._inner[3].a : null;
                    this.bf(l, m, n, k, null, j, h.name, i.name);
                    a.series = Enumerable.a(SeriesDescription.$, j);
                    break;
                }
            case 90:
                {
                    if (false == this.av(1, 1, 1)) {
                        throw new NotSupportedException(1, this.ae._s("Error_InvalidAxesCountOrTypeForChartType", EnumUtil.getName(ChartType_$type, this.c.chartType)));
                    }
                    a = new DataChartDescription();
                    var o = this.j(SpreadsheetChartAdapterHelpers.j(0, this.c._axisCollection$i, this.ag));
                    var p = this.s(SpreadsheetChartAdapterHelpers.j(1, this.c._axisCollection$i, this.ag));
                    var q = this.t(SpreadsheetChartAdapterHelpers.j(3, this.c._axisCollection$i, this.ag));
                    a.axes = [o, p, q];
                    var r = this.a4.count > 0 ? this.a4._inner[0].a : null;
                    var s = this.a4.count > 1 ? this.a4._inner[1].a : null;
                    var t = this.a4.count > 2 ? this.a4._inner[2].a : null;
                    var u = this.a4.count > 3 ? this.a4._inner[3].a : null;
                    var v = new List$1(SeriesDescription.$, 0);
                    v.add(this.y(r, o.name, q.name));
                    v.add(this.w(o.name, p.name));
                    this.bf(s, t, u, null, r, v, o.name, p.name, q.name);
                    a.series = Enumerable.a(SeriesDescription.$, v);
                    break;
                }
            case 91:
                {
                    if (false == this.av(1, 1, 1)) {
                        throw new NotSupportedException(1, this.ae._s("Error_InvalidAxesCountOrTypeForChartType", EnumUtil.getName(ChartType_$type, this.c.chartType)));
                    }
                    a = new DataChartDescription();
                    var w = this.j(SpreadsheetChartAdapterHelpers.j(0, this.c._axisCollection$i, this.ag));
                    var x = this.s(SpreadsheetChartAdapterHelpers.j(1, this.c._axisCollection$i, this.ag));
                    var y = this.t(SpreadsheetChartAdapterHelpers.j(3, this.c._axisCollection$i, this.ag));
                    a.axes = [w, x, y];
                    var z = this.a4.count > 0 ? this.a4._inner[0].a : null;
                    var aa = this.a4.count > 1 ? this.a4._inner[1].a : null;
                    var ab = this.a4.count > 2 ? this.a4._inner[2].a : null;
                    var ac = this.a4.count > 3 ? this.a4._inner[3].a : null;
                    var ad = this.a4.count > 4 ? this.a4._inner[4].a : null;
                    var ae = new List$1(SeriesDescription.$, 0);
                    ae.add(this.y(z, w.name, y.name));
                    ae.add(this.x(w.name, x.name));
                    this.bf(ab, ac, ad, aa, z, ae, w.name, x.name, y.name);
                    a.series = Enumerable.a(SeriesDescription.$, ae);
                    break;
                }
            default: break;
        }
        if (null != a) {
            this.bz(a);
        }
        return a;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.j = function (a) {
        var b = new CategoryXAxisDescription();
        b.name = "XAxis";
        b.label = "CategoryName";
        b.dataSourceRef = "stockdata";
        b.tickLength = 10;
        b.gap = 0.35;
        SpreadsheetChartAdapterHelpers.x(b, a, this.ag);
        b.useClusteringMode = true;
        return b;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.s = function (a) {
        var b = new NumericYAxisDescription();
        b.name = "Prices";
        b.minimumValue = 0;
        b.abbreviateLargeNumbers = true;
        SpreadsheetChartAdapterHelpers.x(b, a, this.ag);
        if (a.visible) {
            var c = "formatlabelstockchartaxis_" + b.name;
            this.ac.v(this.ag.a, this.ag.f, c, function (d, e) {
                if (typeof e === 'number') {
                    var f_2 = e;
                    var g_1 = a._y();
                    if (null != g_1) {
                        var h_1 = stringEmpty();
                        if (((function () { var i = g_1.v(f_2, a.tickLabels.numberFormat, h_1); h_1 = i.p2; return i.ret; })())) {
                            return h_1;
                        }
                    }
                }
                return e.toString();
            });
            b.formatLabelRef = c;
        }
        else {
            b.formatLabelRef = stringEmpty();
        }
        return b;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.t = function (a) {
        var b = new NumericYAxisDescription();
        b.name = "Volume";
        b.minimumValue = 0;
        b.abbreviateLargeNumbers = true;
        SpreadsheetChartAdapterHelpers.x(b, a, this.ag);
        return b;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.v = function (a, b, c, d) {
        var e = new LineSeriesDescription();
        e.showDefaultTooltip = true;
        this.b1(e, a);
        e.title = b;
        e.thickness = 1;
        e.xAxisRef = c;
        e.yAxisRef = d;
        e.dataSourceRef = "stockdata";
        e.valueMemberPath = b;
        return e;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.y = function (a, b, c) {
        var d = new ColumnSeriesDescription();
        d.showDefaultTooltip = true;
        this.b1(d, a);
        d.title = "Volume";
        d.thickness = 1;
        d.xAxisRef = b;
        d.yAxisRef = c;
        d.dataSourceRef = "stockdata";
        d.valueMemberPath = "Volume";
        return d;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.x = function (a, b) {
        var c = new FinancialPriceSeriesDescription();
        c.displayType = EnumUtil.getName(PriceDisplayType_$type, (0));
        c.showDefaultTooltip = true;
        this.b2(c);
        c.title = "Open High Low Close";
        c.thickness = 1;
        c.xAxisRef = a;
        c.yAxisRef = b;
        c.dataSourceRef = "stockdata";
        c.highMemberPath = "High";
        c.lowMemberPath = "Low";
        c.openMemberPath = "Open";
        c.closeMemberPath = "Close";
        return c;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.w = function (a, b) {
        var c = new FinancialPriceSeriesDescription();
        c.displayType = EnumUtil.getName(PriceDisplayType_$type, (1));
        this.b2(c);
        c.title = "High Low Close";
        c.xAxisRef = a;
        c.yAxisRef = b;
        c.dataSourceRef = "stockdata";
        c.highMemberPath = "High";
        c.lowMemberPath = "Low";
        c.openMemberPath = "Open";
        c.closeMemberPath = "Close";
        c.showDefaultTooltip = true;
        return c;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.ap = function (a) {
        if (null == a.bubbleSizes) {
            return false;
        }
        var b = a.bubbleSizes.getValues();
        for (var d = 0; d < b.length; d++) {
            var c = b[d];
            if (null == c || false == (typeof c === 'number' || typeof c === 'number')) {
                return false;
            }
        }
        return true;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.a5 = function () {
        var e_15, _0;
        if (null != this.a0) {
            return this.a0;
        }
        this.a0 = new List$1(SpreadsheetChartAdapter_ScatterSeriesDataItem.$, 0);
        var a = 0;
        try {
            for (var _1 = __values(fromEnum(this.a4)), _2 = _1.next(); !_2.done; _2 = _1.next()) {
                var b = _2.value;
                var c = b.a;
                this.br(c);
                var d = void 0;
                var e = void 0;
                var f = this.bq(c, e, d, true);
                e = f.p1;
                d = f.p2;
                var g = this.ap(c);
                var h = null;
                if (g) {
                    h = c.bubbleSizes.getValues();
                }
                var i = b.c;
                for (var j = 0; j < e.length; j++) {
                    var k = (typeof e[j] === 'number') ? e[j] : typeGetValue(e[j]);
                    var l = (typeof d[j] === 'number') ? d[j] : typeGetValue(d[j]);
                    var m = 0;
                    if (g) {
                        m = (typeof h[j] === 'number') ? h[j] : typeGetValue(h[j]);
                    }
                    this.a0.add(new SpreadsheetChartAdapter_ScatterSeriesDataItem(l, k, m, i));
                }
                a++;
            }
        }
        catch (e_15_1) {
            e_15 = { error: e_15_1 };
        }
        finally {
            try {
                if (_2 && !_2.done && (_0 = _1.return))
                    _0.call(_1);
            }
            finally {
                if (e_15)
                    throw e_15.error;
            }
        }
        return this.a0;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.a6 = function () {
        var e_16, _0;
        if (null != this.a1) {
            return this.a1;
        }
        this.a1 = new List$1(SpreadsheetChartAdapter_SeriesDataItem.$, 0);
        var a = 0;
        try {
            for (var _1 = __values(fromEnum(this.a4)), _2 = _1.next(); !_2.done; _2 = _1.next()) {
                var b = _2.value;
                var c = b.a;
                this.br(c);
                var d = void 0;
                var e = void 0;
                var f = this.bq(c, e, d);
                e = f.p1;
                d = f.p2;
                var _loop_5 = function (g) {
                    var h = b.c;
                    var i = (typeof e[g] === 'number') ? e[g] : typeGetValue(e[g]);
                    var j = g < d.length ? d[g] : null;
                    var k = (null == j) ? "" : j.toString();
                    this_4.a1.add(((function () {
                        var $ret = new SpreadsheetChartAdapter_SeriesDataItem();
                        $ret.Row = k;
                        $ret.Col = h;
                        $ret.Value = i;
                        return $ret;
                    })()));
                };
                var this_4 = this;
                for (var g = 0; g < e.length; g++) {
                    _loop_5(g);
                }
                a++;
            }
        }
        catch (e_16_1) {
            e_16 = { error: e_16_1 };
        }
        finally {
            try {
                if (_2 && !_2.done && (_0 = _1.return))
                    _0.call(_1);
            }
            finally {
                if (e_16)
                    throw e_16.error;
            }
        }
        return this.a1;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bq = function (a, b, c, d) {
        if (d === void 0) {
            d = false;
        }
        var e;
        var f;
        var g = a._dn(e, f);
        e = g.p0;
        f = g.p1;
        var h = e.length;
        for (var i = 0; i < h; i++) {
            var j = e[i];
            if (typeof j === 'number' || typeof j === 'number') {
                e[i] = j;
            }
            else {
                e[i] = 0;
            }
        }
        h = f.length;
        for (var k = 0; k < h; k++) {
            var l = f[k];
            if (d) {
                if (typeof l === 'number' || typeof l === 'number') {
                    f[k] = l;
                }
                else {
                    f[k] = k + 1;
                }
            }
            else {
                if (null == l || typeof l === 'string' && stringIsNullOrEmpty(l)) {
                    f[k] = k;
                }
                else {
                    f[k] = l;
                }
            }
        }
        b = e;
        c = f;
        return {
            p1: b,
            p2: c
        };
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.br = function (a) {
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bs = function () {
        if (null != this.a8 && false == this.ai) {
            this.ai = this.ac.e(this.a8);
        }
        if (null != this.bb && false == this.am) {
            this.am = this.ac.e(this.bb);
        }
        if (this.an) {
            this.bh();
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bt = function () {
        var a = 0;
        var b = 0;
        var c = 1;
        var d = 1;
        var e = 0;
        var f = 0;
        var g = 1;
        var h = 1;
        var i = 0;
        var j = false;
        var k = this.c.legend;
        var l = null != k ? k.position : 6;
        this.ac.t(this.f);
        if (null != this.bb) {
            this.ac.h(this.bb, this.a8);
        }
        var m = function () { return l == 1; };
        var n = function () { return l == 2 || l == 4; };
        var o = function () { return l == 3; };
        var p = function () { return l == 0; };
        if (o()) {
            l = 1;
        }
        else if (p()) {
            l = 2;
        }
        var q = new List$1(RowColLength.$, 0);
        var r = new List$1(RowColLength.$, 0);
        q.add(RowColLength.a);
        i++;
        if (o() && this.aq && false == j) {
            q.add(RowColLength.a);
            i++;
        }
        q.add(new RowColLength(2, 1, 2));
        if (p() && this.aq && false == j) {
            q.add(RowColLength.a);
        }
        if (m() && this.aq && false == j) {
            r.add(RowColLength.a);
        }
        r.add(new RowColLength(2, 1, 2));
        if (n() && this.aq && false == j) {
            r.add(RowColLength.a);
        }
        this.ac.k(this.f, Enumerable.a(RowColLength.$, q), Enumerable.a(RowColLength.$, r));
        if (this.aq) {
            switch (l) {
                case 3:
                    e = i - 1;
                    g = 1;
                    f = 0;
                    h = 1;
                    break;
                case 0:
                case 5:
                case 6:
                    e = false == j ? 2 : 1;
                    g = 1;
                    f = 0;
                    h = 1;
                    break;
                case 1:
                    e = i;
                    g = 1;
                    f = 0;
                    h = 1;
                    break;
                case 2:
                case 4:
                    e = i;
                    g = 1;
                    f = false == j ? 1 : 0;
                    h = 1;
                    break;
            }
        }
        a = 0;
        c = 1;
        b = 0;
        d = 2;
        this.ac.s(this.f, this.a8, 5, true, i, this.aq && m() && false == j ? 1 : 0);
        if (this.aq) {
            if (j) {
                var s = 0;
                switch (l) {
                    case 3:
                        s = 1;
                        break;
                    case 0:
                    case 5:
                    case 6:
                        s = 2;
                        break;
                    case 1:
                        s = 3;
                        break;
                    case 2:
                    case 4:
                        s = 4;
                        break;
                }
                this.ac.c(this.bb, this.a8, s, true);
            }
            else {
                var t = 1;
                var u = 0;
                var v = 1;
                switch (l) {
                    case 3:
                        t = 5;
                        break;
                    case 0:
                    case 5:
                        t = 5;
                        break;
                    case 1:
                        t = 0;
                        u = 4 | 8;
                        break;
                    case 2:
                        t = 0;
                        u = 4 | 8;
                        break;
                    case 4:
                        t = 0;
                        u = 4 | 8 | 1;
                        v = 0;
                        break;
                }
                this.ac.s(this.f, this.bb, t, true, e, f, g, h, 3, v, u);
            }
        }
        if (null != this.c.chartTitle) {
            if (null != this.ad) {
                if (null == this.ba) {
                    this.ba = this.ac.n();
                }
                var w = (null != this.ba);
                if (null == this.a9) {
                    this.a9 = this.ad(this.c, null);
                    if (w) {
                        this.ac.c(this.a9, this.ba, 0);
                    }
                }
                else {
                    this.a9 = this.ad(this.c, this.a9);
                }
                if (w) {
                    this.ac.s(this.f, this.ba, 5, true, a, b, c, d);
                }
                else {
                    this.ac.s(this.f, this.a9, 5, true, a, b, c, d, 1, 3);
                }
            }
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bu = function () {
        if (null != this.ay) {
            this.ay.clear();
            this.ay = null;
        }
        if (null != this.ax) {
            this.ax.clear();
            this.ax = null;
        }
        if (null != this.a2) {
            this.a2.clear();
            this.a2 = null;
        }
        if (null != this.az) {
            this.az.clear();
            this.az = null;
        }
        if (null != this.a1) {
            this.a1.clear();
            this.a1 = null;
        }
        if (null != this.a0) {
            this.a0.clear();
            this.a0 = null;
        }
        if (null != this.a3) {
            this.a3.clear();
            this.a3 = null;
        }
        if (null != this.a8) {
            this.ac.d(this.k, this.a8);
        }
        if (null != this.bb) {
            this.ac.d(this.k, this.bb);
        }
        this.aj = true;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bv = function () {
        this.l = null;
        this.m = null;
        this.ak = true;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bw = function (a) {
        if (a === void 0) {
            a = null;
        }
        var b = (null == a) ? this.l : a;
        if (null == b) {
            return;
        }
        if (null == this.a8) {
            return;
        }
        this.ac.x(this.k, b, this.a8);
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bx = function () {
        if (null != this.m) {
            this.ac.x(this.k, this.m, this.bb);
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.by = function () {
        if (false == this.aq) {
            if (typeCast(SeriesViewerDescription.$, this.l) !== null) {
                this.l.legendRef = null;
            }
            return;
        }
        if (typeCast(SeriesViewerDescription.$, this.l) !== null) {
            this.l.legendRef = "legend";
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.bz = function (a) {
        a.background = "rgba(0, 0, 0, 0)";
        var b = SpreadsheetChartAdapterHelpers.r(this.c.plotArea._ap, this.ah);
        if (false == stringIsNullOrEmpty(b)) {
            a.plotAreaBackground = b;
        }
        else {
            b = SpreadsheetChartAdapterHelpers.r(this.c.chartArea._ap, this.ah);
            if (false == stringIsNullOrEmpty(b)) {
                a.plotAreaBackground = b;
            }
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.b0 = function (a, b) {
        if (!(typeCast(MarkerSeriesDescription.$, a) !== null || typeCast(StackedFragmentSeriesDescription.$, a) !== null)) {
            return;
        }
        var c = 1;
        if (typeCast(BubbleSeriesDescription.$, a) !== null) {
            c = 3;
        }
        else {
            switch (b.markerStyle) {
                case -4105:
                    c = 2;
                    break;
                case 8:
                    c = 3;
                    break;
                case -4115:
                    c = 6;
                    break;
                case 2:
                    c = 7;
                    break;
                case -4118:
                    c = 3;
                    break;
                case -4142:
                    c = 1;
                    break;
                case -4147:
                    c = 3;
                    break;
                case 9:
                    c = 10;
                    break;
                case 1:
                    c = 6;
                    break;
                case 5:
                    c = 11;
                    break;
                case 3:
                    c = 4;
                    break;
                case -4168:
                    c = 4;
                    break;
            }
        }
        if (c == 2) {
            if (typeCast(BubbleSeriesDescription.$, a) !== null && b.chartType == 87) {
                a.markerBrush = "rgba(0,162,232,1)";
                a.markerOutline = "rgba(0, 0, 0, 0)";
                return;
            }
        }
        var d = Enumerable.af(ChartSeriesInfo.$, Enumerable.u(ChartSeriesInfo.$, this.a4, function (e) { return e.a == b; })).b;
        if (typeCast(MarkerSeriesDescription.$, a) !== null) {
            a.markerType = EnumUtil.getName(MarkerType_$type, c);
            var e = SpreadsheetChartAdapterHelpers.r(b._ar(d), this.ah);
            if (false == stringIsNullOrEmpty(e)) {
                a.markerBrush = e;
            }
            if (null != b.markerBorder) {
                e = SpreadsheetChartAdapterHelpers.r(b.markerBorder._ap, this.ah);
                if (false == stringIsNullOrEmpty(e)) {
                    a.markerOutline = e;
                }
            }
        }
        else if (typeCast(StackedFragmentSeriesDescription.$, a) !== null) {
            a.markerType = EnumUtil.getName(MarkerType_$type, c);
            var f = SpreadsheetChartAdapterHelpers.r(b._ar(d), this.ah);
            if (false == stringIsNullOrEmpty(f)) {
                a.markerBrush = f;
            }
            if (null != b.markerBorder) {
                f = SpreadsheetChartAdapterHelpers.r(b.markerBorder._ap, this.ah);
                if (false == stringIsNullOrEmpty(f)) {
                    a.markerOutline = f;
                }
            }
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.b1 = function (a, b) {
        var c = Enumerable.af(ChartSeriesInfo.$, Enumerable.u(ChartSeriesInfo.$, this.a4, function (d) { return d.a == b; }));
        if (null == c) {
            return;
        }
        var d = c.b;
        var e = typeCast(StackedSeriesBaseDescription.$, a) !== null;
        if (false == e) {
            if (2 == b.type) {
                if (null != b.line) {
                    var f = SpreadsheetChartAdapterHelpers.r(b._aq(d), this.ah);
                    if (false == stringIsNullOrEmpty(f)) {
                        a.brush = f;
                    }
                }
            }
            else {
                var g = SpreadsheetChartAdapterHelpers.r(b._ao(d), this.ah);
                if (false == stringIsNullOrEmpty(g)) {
                    a.brush = g;
                }
            }
        }
        if (null != b.border) {
            var h = SpreadsheetChartAdapterHelpers.r(b.border._ap, this.ah);
            if (false == stringIsNullOrEmpty(h)) {
                a.outline = h;
            }
            else {
                a.outline = "rgba(0, 0, 0, 0)";
            }
            a.thickness = SpreadsheetChartAdapterHelpers.n(b.border.widthInPoints, this.ah, false);
        }
        else {
            a.outline = "rgba(0, 0, 0, 0)";
        }
        if (null != b.line) {
            a.thickness = SpreadsheetChartAdapterHelpers.n(b.line.widthInPoints, this.c.worksheet.workbook, false);
        }
        if (false == e) {
            this.b0(a, b);
        }
        if (null != b._trendlineCollection$i && b._trendlineCollection$i.count > 0) {
            var i = b._trendlineCollection$i.item(0);
            var j = EnumUtil.getName(TrendLineType_$type, SpreadsheetChartAdapterHelpers.e(i.trendlineType, i.order));
            var k = i.period;
            var l = SpreadsheetChartAdapterHelpers.r(i.line._as(d), this.ah);
            var m = SpreadsheetChartAdapterHelpers.n(i.line.widthInPoints, this.ah, false);
            if (typeCast(AnchoredCategorySeriesDescription.$, a) !== null) {
                a.trendLineType = j;
                a.trendLinePeriod = k;
                a.trendLineBrush = l;
                a.trendLineThickness = m;
            }
            else if (typeCast(ScatterBaseDescription.$, a) !== null) {
                a.trendLineType = j;
                a.trendLinePeriod = k;
                a.trendLineBrush = l;
                a.trendLineThickness = m;
            }
            else if (typeCast(PolarBaseDescription.$, a) !== null) {
                a.trendLineType = j;
                a.trendLinePeriod = k;
                a.trendLineBrush = l;
                a.trendLineThickness = m;
            }
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.z = function (a, b) {
        DataChartCategoryCoreDescriptionModule.register(this.k.context);
        DataChartCategoryDescriptionModule.register(this.k.context);
        DataChartVerticalCategoryDescriptionModule.register(this.k.context);
        var c = null;
        switch (a.chartType) {
            case 52:
                c = new StackedColumnSeriesDescription();
                break;
            case 53:
                c = new Stacked100ColumnSeriesDescription();
                break;
            case 51:
                c = new ColumnSeriesDescription();
                break;
            case 58:
                c = new StackedBarSeriesDescription();
                break;
            case 59:
                c = new Stacked100BarSeriesDescription();
                break;
            case 57:
                c = new BarSeriesDescription();
                break;
            case 4:
            case 65:
                c = new LineSeriesDescription();
                break;
            case 63:
            case 66:
                c = new StackedLineSeriesDescription();
                break;
            case 64:
            case 67:
                c = new Stacked100LineSeriesDescription();
                break;
            case 1:
                c = new AreaSeriesDescription();
                break;
            case 76:
                c = new StackedAreaSeriesDescription();
                break;
            case 77:
                c = new Stacked100AreaSeriesDescription();
                break;
        }
        if (typeCast(StackedSeriesBaseDescription.$, c) !== null) {
            this.b3(typeCast(StackedSeriesBaseDescription.$, c));
            if (typeCast(HorizontalStackedSeriesBaseDescription.$, c) !== null) {
                c.xAxisRef = a.axisGroup == 1 ? "XAxisPrimary" : "XAxisSecondary";
                c.yAxisRef = a.axisGroup == 1 ? "YAxisPrimary" : "YAxisSecondary";
            }
            else if (typeCast(VerticalStackedSeriesBaseDescription.$, c) !== null) {
                c.xAxisRef = a.axisGroup == 1 ? "XAxisPrimary" : "XAxisSecondary";
                c.yAxisRef = a.axisGroup == 1 ? "YAxisPrimary" : "YAxisSecondary";
            }
        }
        else {
            this.bk(1);
            c.dataSourceRef = stringFormat("groupedseriesdata{0}", b);
            this.b1(c, a);
            if (typeCast(VerticalAnchoredCategorySeriesDescription.$, c) !== null) {
                c.xAxisRef = a.axisGroup == 1 ? "XAxisPrimary" : "XAxisSecondary";
                c.yAxisRef = a.axisGroup == 1 ? "YAxisPrimary" : "YAxisSecondary";
            }
            else if (typeCast(HorizontalAnchoredCategorySeriesDescription.$, c) !== null) {
                c.xAxisRef = a.axisGroup == 1 ? "XAxisPrimary" : "XAxisSecondary";
                c.yAxisRef = a.axisGroup == 1 ? "YAxisPrimary" : "YAxisSecondary";
            }
            c.valueMemberPath = "Value";
        }
        var d = Enumerable.af(ChartSeriesInfo.$, Enumerable.u(ChartSeriesInfo.$, this.a4, function (e) { return e.a == a; }));
        c.name = d.c;
        c.title = d.d;
        c.showDefaultTooltip = true;
        return c;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.b2 = function (a) {
        if (null != this.c.upDownBars) {
            a.brush = SpreadsheetChartAdapterHelpers.r(this.c.upDownBars.upBar._ad, this.ah);
            a.outline = SpreadsheetChartAdapterHelpers.r(this.c.upDownBars.upBar.border._ap, this.ah);
            a.negativeBrush = SpreadsheetChartAdapterHelpers.r(this.c.upDownBars.downBar._ad, this.ah);
            a.negativeOutline = SpreadsheetChartAdapterHelpers.r(this.c.upDownBars.downBar.border._ap, this.ah);
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.u = function (a, b) {
        RingSeriesBaseDescriptionMetadata.d(this.k.context);
        RingSeriesDescriptionMetadata.d(this.k.context);
        HierarchicalRingSeriesDescriptionMetadata.d(this.k.context);
        this.bk(1);
        var c = new RingSeriesDescription();
        c.valueMemberPath = "Value";
        c.labelMemberPath = "Row";
        c.dataSourceRef = stringFormat("groupedseriesdata{0}", b);
        c.tooltipTemplateRef = "doughnutcharttooltip";
        c.brushes = SpreadsheetChartAdapterHelpers.b(a, b);
        if (b == 0) {
            c.legendRef = "legend";
        }
        return c;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.aa = function (a, b, c) {
        DataChartCategoryCoreDescriptionModule.register(this.k.context);
        DataChartCategoryDescriptionModule.register(this.k.context);
        DataChartVerticalCategoryDescriptionModule.register(this.k.context);
        DataChartRadialCoreDescriptionModule.register(this.k.context);
        DataChartRadialDescriptionModule.register(this.k.context);
        var d = null;
        switch (a.chartType) {
            case -4151:
            case 81:
                d = new RadialLineSeriesDescription();
                break;
            case 82:
                d = new RadialAreaSeriesDescription();
                break;
        }
        this.bk(1);
        d.dataSourceRef = stringFormat("groupedseriesdata{0}", b);
        this.b1(d, a);
        d.angleAxisRef = "CategoryAngleAxis";
        d.valueAxisRef = "NumericRadiusAxis";
        d.valueMemberPath = "Value";
        var e = Enumerable.af(ChartSeriesInfo.$, Enumerable.u(ChartSeriesInfo.$, this.a4, function (f) { return f.a == a; }));
        d.name = e.c;
        d.title = e.d;
        d.showDefaultTooltip = true;
        if (this.ar) {
            c.m(a.axisGroup == 1, this.ag);
        }
        return d;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.ab = function (a, b, c) {
        DataChartScatterDescriptionModule.register(this.k.context);
        this.bj();
        var d = null;
        var e = a.chartType;
        if (7 == a.type) {
            d = new BubbleSeriesDescription();
        }
        else {
            switch (e) {
                case -4169:
                    d = new ScatterSeriesDescription();
                    break;
                case 74:
                case 75:
                    d = new ScatterLineSeriesDescription();
                    break;
                case 72:
                case 73:
                    d = new ScatterSplineSeriesDescription();
                    break;
            }
        }
        d.showDefaultTooltip = true;
        this.b1(d, a);
        d.name = Enumerable.af(ChartSeriesInfo.$, Enumerable.u(ChartSeriesInfo.$, this.a4, function (f) { return f.a == a; })).c;
        d.title = Enumerable.af(ChartSeriesInfo.$, Enumerable.u(ChartSeriesInfo.$, this.a4, function (f) { return f.a == a; })).d;
        if (this.ar) {
            d.xAxisRef = a.axisGroup == 1 ? "XAxisPrimary" : "XAxisSecondary";
            d.yAxisRef = a.axisGroup == 1 ? "YAxisPrimary" : "YAxisSecondary";
        }
        else {
            d.xAxisRef = "XAxisPrimary";
            d.yAxisRef = "YAxisSecondary";
        }
        d.dataSourceRef = stringFormat("groupedscatterseriesdata{0}", b);
        d.yMemberPath = "Y";
        d.xMemberPath = "X";
        if (7 == a.type) {
            var f = null != a.bubbleSizes && a.bubbleSizes.getValues().length != 0;
            if (f) {
                d.radiusMemberPath = "Radius";
            }
        }
        if (this.ar) {
            c.n(a.axisGroup == 1, this.ag);
        }
        var g = SpreadsheetChartAdapterHelpers.r(a._aq(b), this.ah);
        if (false == stringIsNullOrEmpty(g)) {
            d.brush = g;
        }
        g = SpreadsheetChartAdapterHelpers.r(a._ar(b), this.ah);
        if (false == stringIsNullOrEmpty(g)) {
            d.markerBrush = g;
        }
        return d;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.b3 = function (a) {
        DataChartStackedDescriptionModule.register(this.k.context);
        this.bn();
        var b = this.a4.count;
        var c = new List$1(StackedFragmentSeriesDescription.$, 0);
        for (var d = 0; d < b; d++) {
            var e = this.a4._inner[d].a;
            if (false == stringContains(EnumUtil.getName(ChartType_$type, e.chartType), "Stacked")) {
                continue;
            }
            var f = new StackedFragmentSeriesDescription();
            f.valueMemberPath = stringFormat("SeriesValues[{0}]", d.toString());
            if (2 == e.type) {
                if (null != e.line) {
                    var g = SpreadsheetChartAdapterHelpers.r(e._aq(d), this.ah);
                    if (false == stringIsNullOrEmpty(g)) {
                        f.brush = g;
                    }
                }
            }
            else {
                var h = SpreadsheetChartAdapterHelpers.r(e._ao(d), this.ah);
                if (false == stringIsNullOrEmpty(h)) {
                    f.brush = h;
                }
            }
            if (null != e.border) {
                var i = SpreadsheetChartAdapterHelpers.r(e.border._ap, this.ah);
                if (false == stringIsNullOrEmpty(i)) {
                    f.outline = i;
                }
                else {
                    f.outline = "rgba(0, 0, 0, 0)";
                }
                f.thickness = SpreadsheetChartAdapterHelpers.n(e.border.widthInPoints, this.ah, false);
            }
            else {
                f.outline = "rgba(0, 0, 0, 0)";
            }
            this.b0(f, e);
            f.name = SpreadsheetChartAdapterHelpers.v(e, d + 1) + "_stacked";
            f.title = SpreadsheetChartAdapterHelpers.w(e, d + 1);
            c.add(f);
        }
        a.dataSourceRef = "stackedseriesdata";
        this.b8(c);
        a.series = Enumerable.a(StackedFragmentSeriesDescription.$, c);
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.au = function (a) {
        var b;
        var c;
        var d = this.bq(a, c, b);
        c = d.p1;
        b = d.p2;
        if (null == c || c.length < 1) {
            return true;
        }
        if (null == a.values) {
            return true;
        }
        var e = true;
        c = a.values.getValues();
        for (var g = 0; g < c.length; g++) {
            var f = c[g];
            if (null != f) {
                e = false;
                break;
            }
        }
        return e;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.b4 = function (a) {
        var e_17, _0;
        try {
            for (var _1 = __values(fromEnum(a.b)), _2 = _1.next(); !_2.done; _2 = _1.next()) {
                var b = _2.value;
                b.a.rangeChangedRef = stringEmpty();
            }
        }
        catch (e_17_1) {
            e_17 = { error: e_17_1 };
        }
        finally {
            try {
                if (_2 && !_2.done && (_0 = _1.return))
                    _0.call(_1);
            }
            finally {
                if (e_17)
                    throw e_17.error;
            }
        }
        if (a.f.count < 1 && a.g.count < 1) {
            return;
        }
        var c = function (d) {
            var e_18, _0;
            try {
                for (var _1 = __values(fromEnum(d)), _2 = _1.next(); !_2.done; _2 = _1.next()) {
                    var e = _2.value;
                    if (null == e.b.majorGridLines) {
                        return false;
                    }
                }
            }
            catch (e_18_1) {
                e_18 = { error: e_18_1 };
            }
            finally {
                try {
                    if (_2 && !_2.done && (_0 = _1.return))
                        _0.call(_1);
                }
                finally {
                    if (e_18)
                        throw e_18.error;
                }
            }
            return true;
        };
        for (var d = 0; d < 2; d++) {
            var e = null;
            var f = stringEmpty();
            if (d == 0) {
                e = a.f;
                if (e.count > 1 && c(e)) {
                    f = "syncrange_xaxis";
                }
                else {
                    continue;
                }
            }
            else {
                e = a.g;
                if (e.count > 1 && c(e)) {
                    f = "syncrange_yaxis";
                }
                else {
                    continue;
                }
            }
            e._inner[0].a.rangeChangedRef = f;
            e._inner[1].a.rangeChangedRef = f;
            var g = function (h, i) {
                var j = truncate(Math.floor(log10(h)));
                var k = h / Math.pow(10, j);
                if (i) {
                    var l = k < 1.5 ? 1 : k < 3 ? 2 : k < 7 ? 5 : 10;
                    return l * Math.pow(10, j);
                }
                else {
                    var m = k <= 1 ? 1 : k <= 2 ? 2 : k <= 5 ? 5 : 10;
                    return m * Math.pow(10, j);
                }
            };
            this.ac.w(this.k, this.a8, f, g);
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.b5 = function (a, b, c) {
        var e_19, _0, e_20, _1, e_21, _2;
        var d = new Dictionary$2(String_$type, Number_$type, 0);
        var e = new Dictionary$2(String_$type, Number_$type, 0);
        try {
            for (var _3 = __values(fromEnum(b)), _4 = _3.next(); !_4.done; _4 = _3.next()) {
                var f = _4.value;
                var g = stringEmpty();
                var h = stringEmpty();
                if (typeCast(StackedSeriesBaseDescription.$, f) !== null) {
                    if (typeCast(HorizontalStackedSeriesBaseDescription.$, f) !== null) {
                        g = f.xAxisRef;
                        h = f.yAxisRef;
                    }
                    else if (typeCast(VerticalStackedSeriesBaseDescription.$, f) !== null) {
                        g = f.xAxisRef;
                        h = f.yAxisRef;
                    }
                }
                else if (typeCast(ScatterBaseDescription.$, f) !== null) {
                    g = f.xAxisRef;
                    h = f.yAxisRef;
                }
                else {
                    if (typeCast(VerticalAnchoredCategorySeriesDescription.$, f) !== null) {
                        g = f.xAxisRef;
                        h = f.yAxisRef;
                    }
                    else if (typeCast(HorizontalAnchoredCategorySeriesDescription.$, f) !== null) {
                        g = f.xAxisRef;
                        h = f.yAxisRef;
                    }
                }
                if (false == d.containsKey(g)) {
                    d.addItem(g, 1.7976931348623157E+308);
                }
                if (false == d.containsKey(h)) {
                    d.addItem(h, 1.7976931348623157E+308);
                }
                if (false == e.containsKey(g)) {
                    e.addItem(g, -1.7976931348623157E+308);
                }
                if (false == e.containsKey(h)) {
                    e.addItem(h, -1.7976931348623157E+308);
                }
                var i = c.item(f);
                var j = 1.7976931348623157E+308;
                var k = -1.7976931348623157E+308;
                var l = void 0;
                var m = void 0;
                var n = this.bq(i, m, l);
                m = n.p1;
                l = n.p2;
                for (var p = 0; p < m.length; p++) {
                    var o = m[p];
                    if (typeof o === 'number') {
                        var q = Convert.toDouble3(o);
                        j = Math.min(j, q);
                        k = Math.max(k, q);
                    }
                }
                var r = d.item(g);
                d.item(g, Math.min(j, r));
                r = d.item(h);
                d.item(h, Math.min(j, r));
                r = e.item(g);
                e.item(g, Math.max(k, r));
                r = e.item(h);
                e.item(h, Math.max(k, r));
            }
        }
        catch (e_19_1) {
            e_19 = { error: e_19_1 };
        }
        finally {
            try {
                if (_4 && !_4.done && (_0 = _3.return))
                    _0.call(_3);
            }
            finally {
                if (e_19)
                    throw e_19.error;
            }
        }
        var s = -1.7976931348623157E+308;
        var t = 1.7976931348623157E+308;
        var u = -1.7976931348623157E+308;
        var v = 1.7976931348623157E+308;
        var w = 0;
        var x = 0;
        try {
            for (var _5 = __values(fromEnum(a.b)), _6 = _5.next(); !_6.done; _6 = _5.next()) {
                var y = _6.value;
                if (typeCast(StraightNumericAxisBaseDescription.$, y.a) !== null) {
                    if (y.b.minimumScaleIsAuto) {
                        var z = Math.floor(d.item(y.a.name));
                        y.a.minimumValue = z;
                        if (y.j) {
                            x++;
                            v = Math.min(v, z);
                        }
                        else {
                            w++;
                            t = Math.min(t, z);
                        }
                    }
                    if (y.b.maximumScaleIsAuto) {
                        var aa = Math.ceil(e.item(y.a.name));
                        y.a.maximumValue = aa;
                        if (y.j) {
                            x++;
                            u = Math.max(u, aa);
                        }
                        else {
                            w++;
                            s = Math.max(s, aa);
                        }
                    }
                }
            }
        }
        catch (e_20_1) {
            e_20 = { error: e_20_1 };
        }
        finally {
            try {
                if (_6 && !_6.done && (_1 = _5.return))
                    _1.call(_5);
            }
            finally {
                if (e_20)
                    throw e_20.error;
            }
        }
        var ab = function (ac, ad, ae) {
            var af = Math.abs(ae - ad);
            return (af / (ad - ac)) <= 0.1;
        };
        var ac = function (ad, ae, af) {
            var ag = Math.abs(af - ad);
            return (ag / (ae - ad)) <= 0.1;
        };
        try {
            for (var _7 = __values(fromEnum(a.b)), _8 = _7.next(); !_8.done; _8 = _7.next()) {
                var ad = _8.value;
                if (typeCast(StraightNumericAxisBaseDescription.$, ad.a) !== null) {
                    if (ad.b.minimumScaleIsAuto) {
                        if (ad.j) {
                            if (x > 1) {
                                var ae = ad.a.minimumValue;
                                if (ae != v && ac(v, u, ae)) {
                                    ad.a.minimumValue = v;
                                }
                            }
                        }
                        else {
                            if (w > 1) {
                                var af = ad.a.minimumValue;
                                if (af != t && ac(t, s, af)) {
                                    ad.a.minimumValue = t;
                                }
                            }
                        }
                    }
                    if (ad.b.maximumScaleIsAuto) {
                        if (ad.j) {
                            if (x > 1) {
                                var ag = ad.a.maximumValue;
                                if (ag != v && ab(v, u, ag)) {
                                    ad.a.maximumValue = u;
                                }
                            }
                        }
                        else {
                            if (w > 1) {
                                var ah = ad.a.maximumValue;
                                if (ah != t && ac(t, s, ah)) {
                                    ad.a.maximumValue = s;
                                }
                            }
                        }
                    }
                }
            }
        }
        catch (e_21_1) {
            e_21 = { error: e_21_1 };
        }
        finally {
            try {
                if (_8 && !_8.done && (_2 = _7.return))
                    _2.call(_7);
            }
            finally {
                if (e_21)
                    throw e_21.error;
            }
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.b6 = function () {
        if (false == this.ae._e.contains(this.c.chartType)) {
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.av = function (a, b, c) {
        var e_22, _0;
        var d = 0;
        var e = 0;
        var f = 0;
        try {
            for (var _1 = __values(fromEnum(this.c._axisCollection$i)), _2 = _1.next(); !_2.done; _2 = _1.next()) {
                var g = _2.value;
                if (g.type == 1 && g.visible) {
                    d++;
                }
                else if (g.axisGroup == 1 && g.visible) {
                    e++;
                }
                else if (g.axisGroup == 2 && g.visible) {
                    f++;
                }
            }
        }
        catch (e_22_1) {
            e_22 = { error: e_22_1 };
        }
        finally {
            try {
                if (_2 && !_2.done && (_0 = _1.return))
                    _0.call(_1);
            }
            finally {
                if (e_22)
                    throw e_22.error;
            }
        }
        return d == a && e == b && f == c;
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.b7 = function (a) {
        var e_23, _0;
        var b = new HashSet$1(String_$type, 0);
        try {
            for (var _1 = __values(fromEnum(a)), _2 = _1.next(); !_2.done; _2 = _1.next()) {
                var c = _2.value;
                var d = c.name;
                while (b.contains(d)) {
                    d = c.name + this.ag.e().toString();
                }
                b.add_1(d);
                if (c.name != d) {
                    c.name = d;
                }
            }
        }
        catch (e_23_1) {
            e_23 = { error: e_23_1 };
        }
        finally {
            try {
                if (_2 && !_2.done && (_0 = _1.return))
                    _0.call(_1);
            }
            finally {
                if (e_23)
                    throw e_23.error;
            }
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.prototype.b8 = function (a) {
        var e_24, _0;
        var b = new HashSet$1(String_$type, 0);
        try {
            for (var _1 = __values(fromEnum(a)), _2 = _1.next(); !_2.done; _2 = _1.next()) {
                var c = _2.value;
                var d = c.name;
                while (b.contains(d)) {
                    d = c.name + this.ag.e().toString();
                }
                b.add_1(d);
                if (c.name != d) {
                    c.name = d;
                }
            }
        }
        catch (e_24_1) {
            e_24 = { error: e_24_1 };
        }
        finally {
            try {
                if (_2 && !_2.done && (_0 = _1.return))
                    _0.call(_1);
            }
            finally {
                if (e_24)
                    throw e_24.error;
            }
        }
    };
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.$t = markType(SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate, 'SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate', SpreadsheetChartElementInfo.$);
    return SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate;
}(SpreadsheetChartElementInfo));
export { SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate };
